<?xml version="1.0" encoding="UTF-8"?>
<?xar Schematron?>
<!-- 
  This schema validates a consolidated workbook from XSLX for importing as PSXML.

  @author Christophe Lauret
  @version 26 October 2011

  @copyright (C) 2011 Weborganic Systems Pty. Ltd.
-->
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron" queryBinding="xslt2" >

    <sch:title>Validation for importing XSLX (Excel) as PSXML</sch:title>

    <!-- Check content of the XSLT for import -->
    <sch:pattern id="ImportRules">

        <!-- At the workbook level -->
        <sch:rule context="workbook">

            <!-- There must be at least one sheet with one row to import data -->
            <sch:assert test="sheet[row]">This workbook does not contain any data (sheets are empty)</sch:assert>

        </sch:rule>

        <!-- For sheets which contain rows -->
        <sch:rule context="sheet[row]">

            <!-- Report the number of rows in the sheet -->
            <sch:report test="true()">Found <sch:value-of select="count(row)"/> row(s) in worksheet "<sch:value-of select="@name"/>"</sch:report>

            <!-- Assert that all rows are a consistent span -->
            <sch:assert test="count(distinct-values(row/@spans)) = 1">Inconsistent number of columns per row in worksheet "<sch:value-of select="@name"/>"</sch:assert>

            <!-- Report the number of columns we can import in the sheet -->
            <sch:report test="row/col">Found <sch:value-of select="count(row[1]/col)"/> columns per row in worksheet "<sch:value-of select="@name"/>"</sch:report>

        </sch:rule>

    </sch:pattern>

</sch:schema>
