<?xml version="1.0"?>

<!--
  Generate an HTML file listing the URIs processed by their paths.
  The XML input is a list of URIs. 
 -->

<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:enc="java:java.net.URLEncoder" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns="http://www.w3.org/1999/xhtml">

	<xsl:param name="siteprefix" select="''" />

  <xsl:output encoding="iso-8859-1" method="html" />

	<xsl:template match="/">
    <html>
      <head><title>Files Processed</title></head>
      <style type="text/css">
      body {
        color:#036299;
        font-size:11px;
        font-family:Tahoma,Arial,Helvetica,sans-serif;
      }
      </style>
      <xsl:comment>no seeding</xsl:comment>
      <body>
        <h2>Files Processed</h2>
        <xsl:apply-templates select="//uri">
          <xsl:sort select="path"/>
        </xsl:apply-templates>
      </body>
    </html>
	</xsl:template>

	<xsl:template match="uri">
	  <div>
	    <span class="path"><xsl:value-of select="decodedpath" /></span>
			<xsl:if test="starts-with(type,'image/')">
				<xsl:text/> (<span class="imagepath"><xsl:value-of select="concat($siteprefix,'/uri/',id,'.',tokenize(decodedpath, '[.]')[last()])" /></span>)<xsl:text/>
			</xsl:if>
		</div>
	</xsl:template>
  
</xsl:stylesheet>

