<?xml version="1.0"?>
<!--
  Templates used to display the files for a project.

  @author Jean-Baptiste Reure
  @author Christophe Lauret
  @version 17 March 2011
-->
<xsl:stylesheet version="2.0" xmlns="http://www.w3.org/1999/xhtml"
                              xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:xs="http://www.w3.org/2001/XMLSchema"
                              xmlns:psf="http://www.pageseeder.com/function"
                              exclude-result-prefixes="xs psf">

  <!-- Main template -->
  <xsl:template match="content[@name = 'about']">
    <h2>About Publisher</h2>
    <div class="buildnumber">Publisher Server Version: <xsl:value-of select="about/buildnumber" /></div>
    <xsl:variable name="all" select="round(count(about//library) div 2)" />
    
    <table class="libraries" cellspacing="0" cellpadding="0">
      <thead>
        <tr>
          <th>Library Name</th>
          <th>Library Version</th>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select="about//library[position() le $all]">
          <xsl:sort select="." />
          <tr class="library {if (position() mod 2 = 0) then 'even' else 'odd'}">
            <td class="name">
              <xsl:value-of select="." />
              <xsl:if test="@extension != 'jar'"> (<span class="extension"><xsl:value-of select="@extension" /></span>)</xsl:if>
            </td>
            <td class="version"><xsl:value-of select="@version" /></td>
          </tr>
        </xsl:for-each>
      </tbody>
    </table>
    
    <table class="libraries" cellspacing="0" cellpadding="0">
      <thead>
        <tr>
          <th>Library Name</th>
          <th>Library Version</th>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select="about//library[position() gt $all]">
          <xsl:sort select="." />
          <tr class="library {if (position() mod 2 = 0) then 'even' else 'odd'}">
            <td class="name">
              <xsl:value-of select="." />
              <xsl:if test="@extension != 'jar'"> (<span class="extension"><xsl:value-of select="@extension" /></span>)</xsl:if>
            </td>
            <td class="version"><xsl:value-of select="@version" /></td>
          </tr>
        </xsl:for-each>
      </tbody>
    </table>
  </xsl:template>
  
</xsl:stylesheet>
